/*
 * inflash.h
 *
 *  Created on: 2024624
 *      Author: psx
 */

#ifndef APP_INC_INFLASH_H_
#define APP_INC_INFLASH_H_

#include "debug.h"

#pragma pack(push,1)

/* ֽǰֽں */
typedef struct _recv_config_info{
    uint8_t start_Flag[2];                  /* ʼ־ */
    /* SL */
    uint8_t address[7];                     /* ַ */
    uint8_t Access_Node_Type[2];            /* ڵ  */
    uint8_t Communication_Methods[2];       /* ͨŷʽ  */
    uint8_t gw485_Baud[4];                  /* ڲ,Ϊ0bms֧ͨ */
    uint8_t bat485_Baud[4];                 /* ڲ */

    /* HY */
    uint8_t hardwareID[6];                  /* ӲID */
    uint8_t communicationID[4];             /* ͨID */
    uint8_t protocolType;                   /* Э;  0x01ʾԴЭ(9600) 0x02ʾЭ(115200)*/

    uint8_t ConstantVoltageV[2];            /* ڸ(ѹ / 100)ҵFloatI * 100кѹ */
    uint8_t FloatI[2];                      /* ڸ(ѹ / 100)ҵFloatI * 100и */
    uint8_t startSolarOpenCircuitV[2];      /* ڸ(ѹ / 100)ʼ */
    uint8_t stopSolarOpenCircuitV[2];       /* ̫ܰ忪·ѹڸõѹֹͣ  (V) */
    uint8_t constantVoltageChargeV[2];      /* ѹʱѹ  (V) */
    uint8_t FloatV[2];                      /* ʱѹ  (V) */
    uint8_t HighSideMosTemperature_stop[2]; /* ¶ȴﵽֵʱֹͣ  (C) */
    uint8_t HighSideMosTemperature_end[2];  /* ¶ֵʱ͹  (C) */
    uint8_t HighSideMosTemperature_start[2];/* ¶Ƚ͵ֵʱ  (C) */
    uint8_t loopImpedance[2];               /* ·迹С  (m) */

    uint8_t checkSolarOpenCircuitVTime[2];  /* ̫ܰ忪·ѹʱ  (S) */
    uint8_t outputAgainFlagTime[2];         /* ֶ·ӳöʱٴμǷ·Ȼ·ر  (S) */
    uint8_t excessiveLoadFlagTime[2];       /* ֹغڸüʱжΣ2Σֹأر  (S) */
    uint8_t eLAgainTime[2];                 /* ֹعرڸüʱٴγ  (S) */
    uint8_t crc[2];                         /* У */
    uint8_t end_Flag;                       /* ־ */
}recv_config_info;

typedef struct _config_info{
    /* SL */
    uint8_t address[7];                     /* ַ */
    uint8_t Access_Node_Type[2];            /* ڵ  */
    uint8_t Communication_Methods[2];       /* ͨŷʽ  */
    uint8_t gw485_Baud[4];                  /* ڲ,Ϊ0bms֧ͨ */
    uint8_t bat485_Baud[4];                 /* ڲ */

    /* HY */
    uint8_t hardwareID[6];                  /* ӲID */
    uint8_t communicationID[4];             /* ͨID */
    uint8_t protocolType;                   /* Э;  0x01ʾԴЭ(9600) 0x02ʾЭ(115200)*/

    uint16_t constantVoltageV;              /* ѹڸ(ConstantVoltageV / 100)ҵڣFloatI / 100 + 0.1кѹ */
    uint16_t floatI;                        /* ѹڸ(ConstantVoltageV / 100)ҵڣFloatI / 100и */
    uint16_t startSolarOpenCircuitV;        /* ̫ܰ忪·ѹڸ(ѹ / 100)ʼ */
    uint16_t stopSolarOpenCircuitV;         /* ̫ܰ忪·ѹڸ(ѹ / 100)ֹͣ */
    uint16_t constantVoltageChargeV;        /* ѹʱѹ */
    uint16_t FloatV;                        /* ѹ */
    uint16_t checkSolarOpenCircuitVTime;    /* ̫ܰ忪·ѹʱ */
    uint16_t registerRefreshTime;           /* Ĵˢʱ */
    uint16_t sensorEnableBroadcastTime;     /* ٴעļ */
    uint16_t HighSideMosTemperature_stop;   /* ¶ȴﵽֵʱֹͣ */
    uint16_t HighSideMosTemperature_end;    /* ¶ֵʱ͹ */
    uint16_t HighSideMosTemperature_start;  /* ¶Ƚ͵ֵʱ */
    uint16_t loopImpedance;                 /* ·迹С  (m) */

    uint16_t outputAgainFlagTime;           /* ֶ·ӳöʱٴμǷ·Ȼ·ر */
    uint16_t excessiveLoadFlagTime;         /* ֹغڸöʱٴγֹأر */
    uint16_t eLAgainTime;                   /* ֹعر󣬸öʱٴγ */

    uint16_t crc;                           /* У */
}config_info;
#define CONFIG_INFO_SIZE    (sizeof(config_info))
#pragma pack(pop)

#define CONFIG_SAVE_ADDR_BEGIN   (0x00)
#define CONFIG_SAVE_ADDR_END     (0x00 + CONFIG_INFO_SIZE)


#endif /* APP_INC_INFLASH_H_ */
