/*
 * parameter.h
 *
 *  Created on: 20241012
 *      Author: psx
 */

#ifndef APP_INC_PARAMETER_H_
#define APP_INC_PARAMETER_H_

#include "debug.h"
#include "math.h"
#include "uart_dev.h"


typedef struct _Mppt_controlparameter{
    float_t constantVoltageV;               /* ѹConstantVoltageVҵڣFloatI + 0.1кѹ
                                                                                                                                                             ѹڸ(ConstantVoltageV - 0.2) к  (V) */
    float_t floatI;                         /* ѹڸConstantVoltageVҵFloatIи  (A) */
    float_t startSolarOpenCircuitV;         /* ̫ܰ忪·ѹڸõѹʼ  (V) */
    float_t stopSolarOpenCircuitV;          /* ̫ܰ忪·ѹڸõѹֹͣ  (V) */
    float_t constantVoltageChargeV;         /* ѹʱѹ  (V) */
    float_t FloatV;                         /* ʱѹ  (V) */
    float_t loopImpedance;                  /* ·迹С  (m) */
    float_t HighSideMosTemperature_stop;    /* ¶ȴﵽֵʱֹͣ  (C) */
    float_t HighSideMosTemperature_end;     /* ¶ֵʱ͹  (C) */
    float_t HighSideMosTemperature_start;   /* ¶Ƚ͵ֵʱ  (C) */

    uint16_t sensorEnableBroadcastTime;     /* ٴעļ */
    uint16_t checkSolarOpenCircuitVTime;    /* ̫ܰ忪·ѹʱ  (S) */
    uint16_t outputAgainFlagTime;           /* ֶ·ӳöʱٴμǷ·Ȼ·ر  (S) */
    uint16_t excessiveLoadFlagTime;         /* ֹغڸüʱжΣ2Σֹأر  (S) */
    uint16_t eLAgainTime;                   /* ֹعرڸüʱٴγ  (S) */


} Mppt_controlparameter;
extern Mppt_controlparameter g_controlParameter;

typedef struct _Mppt_otherParameter{
    /* SL */
    uint8_t address[7];                     /* ַ */
    uint16_t Access_Node_Type;              /* ڵ  */
    uint16_t Communication_Methods;         /* ͨŷʽ  */
    uint16_t Registration_Status;           /* ע״̬  */
    uint32_t gw485_Baud;                    /* ڲ */
    uint32_t bat485_Baud;                   /* ڲ,Ϊ0bms֧ͨ */

    /* HY */
    uint8_t hardwareID[6];                  /* ӲID */
    uint8_t communicationID[4];             /* ͨID */
    uint8_t protocolType;                   /* Э;  0x01ʾԴЭ(9600) 0x02ʾЭ(115200)*/


    float_t Battery_Voltage;                /* صѹ  (V) */
    float_t Output_Voltage;                 /* ѹ */
    float_t Charg_Current;                  /* +أ  (A) */
    float_t Discharg_Current;               /* ŵأ  (A) */
    float_t Input_Voltage;                  /* ̫ܰѹ  (V) */
    float_t Solar_Open_Circuit_Voltage;     /* ̫ܰ忪·ѹ  (V) */
    float_t HighSideMos_Temperature;        /* ߶mos¶  (C) */
    float_t Solar_In_Circuit_Voltage;       /* ̫ܰѹ  (V) */

    float_t Charg_BatteryCurrent;           /* سأ  (A) */
    float_t totalElectricityConsumption;    /* ܵ */
    float_t totalChargCapacity;             /* ܳ */
    float_t SOC;                            /* ʣ */

    uint16_t chargMos_State;                /* 翪״̬ */
    uint16_t DischargMos_State;             /* ŵmos״̬ */
    uint16_t MPPT_Mode;                     /* ģʽ */

    uint8_t versionInformation[13];         /* 汾Ϣ */


}Mppt_otherParameter;
extern Mppt_otherParameter g_otherParameter;


#endif /* APP_INC_PARAMETER_H_ */
